local M = {}

local leftIsOn = false
local rightIsOn = false

local steerAngle = 0

local function updateGFX()
    if electrics.values.running == true then
        if electrics.values.wheelspeed < 0.1 then
            leftIsOn = false
            rightIsOn = false
            electrics.values.cornering_R = 1
            electrics.values.cornering_L = 1
        else
            if electrics.values.steering < (steerAngle * -1) then
                rightIsOn = true
            else
                rightIsOn = false
            end
            if electrics.values.steering > steerAngle then
                leftIsOn = true
            else
                leftIsOn = false
            end
        end

        if leftIsOn == true then
            electrics.values.cornering_L = 1
            electrics.values.cornering_R = 0
        end
        if rightIsOn == true then
            electrics.values.cornering_L = 0
            electrics.values.cornering_R = 1
        end
        if  leftIsOn == false and rightIsOn == false then
            electrics.values.cornering_L = 1
            electrics.values.cornering_R = 1
        end
    else
        electrics.values.cornering_R = 0
        electrics.values.cornering_L = 0

        leftIsOn = false
        rightIsOn = false
    end
end

local function init(jbeamData)
    steerAngle = jbeamData.steerAngle or 150

    electrics.values.cornering_R = 0
    electrics.values.cornering_L = 0

    leftIsOn = false
    rightIsOn = false
end

M.reset = init
M.init = init
M.updateGFX = updateGFX

return M