-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1. (Yes I know this is my own code, bCDDL still applies)
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}
M.type = "auxilliary"

local powerStage1 = nil
local powerStage2 = nil
local powerStage3 = nil
local powerStage4 = nil
local powerStage5 = nil

local state = 0
local gearbox = powertrain.getDevice("gearbox")

local origFriction = nil

local function init(jbeamData)
    powerStage1 = jbeamData.powerStage1 or 1000
    powerStage2 = jbeamData.powerStage2 or 1500
    powerStage3 = jbeamData.powerStage3 or 2000
    powerStage4 = jbeamData.powerStage4 or 2500
    powerStage5 = jbeamData.powerStage5 or 3000
    origFriction = gearbox.friction
end

local function updateGFX(dt)
    if electrics.values.throttle > 0.1 then
        state = 0
    elseif electrics.values.wheelspeed <= 1.7 then
        state = 0
    elseif gearbox.gearRatios[gearbox.gearIndex] == 0 then
        state = 0
        return false
    end
    if state == 0 then
        gearbox.friction = origFriction
        --guihooks.message("state 0", 10, "vehicle.retarder.state")
    elseif state == 1 then
        gearbox.friction = origFriction + powerStage1
        --guihooks.message("state 1", 10, "vehicle.retarder.state")
    elseif state == 2 then
        gearbox.friction = origFriction + powerStage2
        --guihooks.message("state 2", 10, "vehicle.retarder.state")
    elseif state == 3 then
        gearbox.friction = origFriction + powerStage3
        --guihooks.message("state 3", 10, "vehicle.retarder.state")
    elseif state == 4 then
        gearbox.friction = origFriction + powerStage4
        --guihooks.message("state 4", 10, "vehicle.retarder.state")
    elseif state == 5 then
        gearbox.friction = origFriction + powerStage5
        --guihooks.message("state 5", 10, "vehicle.retarder.state")
    end

    --input part
    if electrics.values.retarder_up == 1 then
        state = state + 1
        electrics.values.retarder_up = 0
    elseif electrics.values.retarder_down == 1 then
        state = state - 1
        electrics.values.retarder_down = 0
    elseif electrics.values.retarder_max == 1 then
        state = 5
        electrics.values.retarder_max = 0
    elseif electrics.values.retarder_off == 1 then
        state = 0
        electrics.values.retarder_off = 0
    end

    -- avoid state jumping to anything over 5 or under 0
    if state >= 6 then
        state = 5
    elseif state <= -1 then
        state = 0
    end
end

M.init = init
M.updateGFX = updateGFX
return M